
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 *       ,
 *     .
 *      
 *      -     
 *   .  ,     
 * ,   " "
 *
 * Date: 26.03.2006
 */
public class Pyramid {
    /**
     *  ,       .
     */
    public static class IndexedArray implements Comparable {
        int[] array;    //  
        int i;          //     

        //  
        IndexedArray(int[] array, int i) { this.array = array; this.i = i; }

        //     ()  .
        //         ;
        //    ,    " " 
        public int compareTo(IndexedArray ia) {
            if (i == array.length && ia.i == ia.array.length)
                return 0;       //      
            else if (i == array.length)
                return 1;       //   ""    
            else if (ia.i == ia.array.length)
                return -1;      //   "    
            else
                //     
                return array[i] - ia.array[ia.i];
        }

        public int compareTo(Object o) {
            return compareTo((IndexedArray)o);
        }

        //     ,   compareTo,
        //     ,   
        //      .
        public boolean equals(IndexedArray ia) {
            if (i == array.length && ia.i == ia.array.length)
                return true;       //      
            else if (i == array.length || ia.i == ia.array.length)
                return false;       //       
            else
                //  " 
                return array[i] == ia.array[ia.i];
        }

        public boolean equals(Object obj) {
            return equals((IndexedArray)obj);
        }
    }

    private int size = 0;           //   
    private IndexedArray[] body;    //     

    /**
     *      
     * @param size -  
     */
    Pyramid(int size) {
        //  :
        body = new IndexedArray[size];
    }

    //     (  )
    public int size() { return size; }

    //     
    public boolean isEmpty() { return size == 0; }

    /**
     *     .  
     *    ,   ""  ,
     *   ,   .
     * @param ia -  
     */
    public void add(IndexedArray ia) {
        body[size] = ia;    //     
        int q = size++;     //    ""
        int p = q;          //  "" 
        while (p != 0) {
            p = (p-1)/2;    //   
            if (body[p].compareTo(body[q]) > 0) {
                //      ""
                IndexedArray tmp = body[q]; body[q] = body[p]; body[p] = tmp; q = p;
            } else {
                //     ; "" 
                break;
            }
        }
    }

    //   ( )  
    public IndexedArray top() { return body[0]; }

    //     .
    //     ,   
    // ""   ,    .
    public void shrink() {
        if (--size > 0) {
            body[0] = body[size];   //  
            update();               // ""
        }
    }

    /**
     *  ""       .
     */
    public void update() {
        int p = 0, q;       //      " "
        while((q = 2*p+1) < size) {
            //    .
            //           
            if (q+1 < size && body[q+1].compareTo(body[q]) < 0) q++;
            if (body[p].compareTo(body[q]) > 0) {
                //  ,   ,   
                IndexedArray tmp = body[q]; body[q] = body[p]; body[p] = tmp; p = q;
            } else {
                //      , "" 
                break;
            }
        }
    }

    //  ,      .
    // ,         .
    //   true,       .
    public boolean allEqual() {
        int elem = body[0].array[body[0].i];
        for (int i = 1; i < size; i++) {
            if (elem != body[i].array[body[i].i]) return false;
        }
        return true;
    }
}
